unit gui;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLWin32Viewer, GLMisc, GLTexture, Keyboard,
  ExtCtrls;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLDummyCube1: TGLDummyCube;
    GLCamera1: TGLCamera;
    GLMaterialLibrary1: TGLMaterialLibrary;
    Image1: TImage;
    GLLightSource1: TGLLightSource;
    Timer1: TTimer;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    procedure loadstars;
    procedure checkstars;

  public
    { Public declarations }
  end;

const
numberstars = 255;
fieldsize = 100;
halffieldsize = 50;

var
  Form1: TForm1;
  vx, vy: integer;
  StarField: Array[0..numberstars] of TObject;

implementation

{$R *.dfm}

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
vx := x; vy := y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if shift <> [ssLeft] then exit;
GLCamera1.MoveAroundTarget(vy - y, vx - x);
vx:= x; vy:= y;
end;

procedure TForm1.loadstars;
var
x: integer;
begin
for x:= 0 to numberstars do
  StarField[x] := GLScene1.Objects.AddNewChild(TGLSprite);
Randomize;
for x:= 0 to numberstars do
  with (StarField[x] as TGLSprite) do
  begin
  Position.X := Random(fieldsize) - halffieldsize;
  Position.Y := Random(fieldsize) - halffieldsize;
  Position.Z := Random(fieldsize) - halffieldsize;
  Material := Form1.GLMaterialLibrary1.Materials.Items[0].Material;
  end;
end;

procedure TForm1.checkstars;
var
x: integer;
begin
for x:= 0 to numberstars do
  with (StarField[x] as TGLSprite) do
  begin
  if abs(Position.X - GLDummyCube1.Position.X) > halffieldsize then
    Position.X := Position.X - 2*(Position.X - GLDummyCube1.Position.X);
  if abs(Position.Y - GLDummyCube1.Position.Y) > halffieldsize then
    Position.Y := Position.Y - 2*(Position.Y - GLDummyCube1.Position.Y);
  if abs(Position.Z - GLDummyCube1.Position.Z) > halffieldsize then
    Position.Z := Position.Z - 2*(Position.Z - GLDummyCube1.Position.Z);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Image1.Picture.LoadFromFile('star.bmp');
GLMaterialLibrary1.Materials[0].Material.Texture.Image.Assign(Image1.Picture);
loadstars;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if IsKeyDown(38) then
  begin
  GLDummyCube1.Position.X := GLDummyCube1.Position.X + GLSceneViewer1.Buffer.ScreenToVector(GLSceneViewer1.Width div 2, GLSceneViewer1.Height div 2)[0];
  GLDummyCube1.Position.Y := GLDummyCube1.Position.Y + GLSceneViewer1.Buffer.ScreenToVector(GLSceneViewer1.Width div 2, GLSceneViewer1.Height div 2)[1];
  GLDummyCube1.Position.Z := GLDummyCube1.Position.Z + GLSceneViewer1.Buffer.ScreenToVector(GLSceneViewer1.Width div 2, GLSceneViewer1.Height div 2)[2];
  end
else if IsKeyDown(40) then
  begin
  GLDummyCube1.Position.X := GLDummyCube1.Position.X - GLSceneViewer1.Buffer.ScreenToVector(GLSceneViewer1.Width div 2, GLSceneViewer1.Height div 2)[0];
  GLDummyCube1.Position.Y := GLDummyCube1.Position.Y - GLSceneViewer1.Buffer.ScreenToVector(GLSceneViewer1.Width div 2, GLSceneViewer1.Height div 2)[1];
  GLDummyCube1.Position.Z := GLDummyCube1.Position.Z - GLSceneViewer1.Buffer.ScreenToVector(GLSceneViewer1.Width div 2, GLSceneViewer1.Height div 2)[2];
  end;
checkstars;
end;

end.
